% Autor: Wiebke Petersen
% Datum: 04.05.2017
% Letzte Sitzung kam die Idee auf alle mglichen Sudokuspiele zu generieren und in die Wissensbasis
% zu schreiben. Das eigentliche Sudokuprdikat msste dann nur noch berprfen, welche der Spiele in
% der Wissensbasis mit der Aufgabenstellung kompatibel sind.
% Fr ein 4x4 Brett ist das kein Problem. Wieviele Bretter mssen bei der Gre 9x9 berprft werden?

% ?- generate_all,listing(boards:board/1).
:- abolish(boards:board/1).
use_module(library(lists)).

generate_all:-
   lists:permutation([1,2,3,4],L1),
   lists:permutation([1,2,3,4],L2),
   lists:permutation([1,2,3,4],L3),
   lists:permutation([1,2,3,4],L4),
   L = [L1,L2,L3,L4],

%    lists:permutation([1,2,3,4,5,6,7,8,9],L1),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L2),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L3),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L4),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L5),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L6),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L7),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L8),
%    lists:permutation([1,2,3,4,5,6,7,8,9],L9),
%    L = [L1,L2,L3,L4,L5,L6,L7,L8,L9],
   consistent(L),
   assert(boards:board([L1,L2,L3,L4])),
   fail.

generate_all.


consistent(L):-
   col_consistent(L,[],[]),
   block_consistent(L).
   

col_consistent([[]|_],_,_):-!.
col_consistent([],Acc1,Acc2):-
   \+double(Acc1),
   col_consistent(Acc2,[],[]).

col_consistent([[H|T1]|T2],Acc1,Acc2):-
   col_consistent(T2,[H|Acc1],[T1|Acc2]).

block_consistent(L):-
   length(L,N),
   M is round(sqrt(N)),
   control_block(M,M,M,L,[],[]).

control_block(M,M,M,[],[],[]):- !.
control_block(_,0,M,T,Acc1,Acc2):- !,
   \+double(Acc1),
   control_block(M,M,M,Acc2,[],T).
control_block(0,C,M,[H|T],Acc1,Acc2):-!,
   CN is C-1,
   control_block(M,CN,M,T,Acc1,[H|Acc2]).
control_block(R,C,M,[[]|T2],Acc1,Acc2):-!,
   control_block(R,C,M,T2,Acc1,Acc2).
control_block(R,C,M,[[H|T1]|T2],Acc1,Acc2):-
   RN is R-1,
   control_block(RN,C,M,[T1|T2],[H|Acc1],Acc2).

double([H|T]):-
   member(H,T),!.

double([_H|T]):-
   double(T).


% Anzahl der zu berprfenden Bretter
% 4x4: 281474976710656
% 9x9: 685375061799245404142145505972949894980477656349630971258866971407031614265280541298434511512329275289030738829528084278076605595703563028486064545739122933128158387201
